package com.winhc.data.push.task;


import com.aliyun.openservices.shade.org.apache.commons.lang3.StringUtils;
import com.winhc.data.push.common.TaskEnum;
import com.winhc.data.push.service.SynDataService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.bson.Document;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.FileNotFoundException;
import java.util.List;

import static com.winhc.data.push.constant.BaseParam.SYN_ANSHUO_UPLOAD_TASKS;
import static com.winhc.data.push.constant.BaseParam.SYN_TC_UPLOAD_TASKS;

/**
 * @author π
 * @Description:58同城触发任务
 * @date 2021/6/22 17:07
 */

@Component
@Slf4j
@EnableScheduling
@AllArgsConstructor
public class TcPushDataTask {

    private final SynDataService synDataService;

    @Scheduled(cron = "*/10 * * * * ?")
    //@Scheduled(cron = "0 /2 * * * ? ")
    public synchronized void start() {
        log.info("start " + this.getClass() + " !!! ");
        //获取运行任务
        List<Document> allTask = synDataService.findAllTask(SYN_TC_UPLOAD_TASKS, new Document("status", "create"));
        allTask.forEach(task -> {
            String ds = task.getString("ds");
            List<String> tns = task.getList("tns", String.class);
            if (StringUtils.isNotBlank(ds)) {
                synDataService.pushTc(tns, ds);
            }
        });
        log.info("stop " + this.getClass() + " !!! ");

    }


}
