package com.winhc.data.push.utils;

import com.aliyun.openservices.shade.org.apache.commons.lang3.StringUtils;

import static cn.hutool.crypto.SecureUtil.md5;
import static com.winhc.data.push.constant.BaseParam.SYN_TC_ID_SUF;
import static com.winhc.data.push.utils.DateUtils.*;

/**
 * @author π
 * @Description:
 * @date 2022/7/24 13:38
 */
public class BaseUtils {

    public static Boolean isWindows() {
        return System.getProperty("os.name").contains("Windows");
    }

    public static Boolean verifyDate(String ds) {
        if (StringUtils.isBlank(ds) || ds.length() != 8) return false;
        if (StringUtils.isBlank(parseDate(ds))) return false;
        String now = nowDate(YYYYMMDD);
        return ds.compareTo(now) < 0;
    }

    public static final String salt = "winhc_data_push";

    public static String getDetailName(String ds, String tn) {
        assert StringUtils.isNotBlank(ds);
        assert StringUtils.isNotBlank(tn);
        return md5(ds + "@" + tn + "@" + salt) + ".json";
    }

    public static String getPrcessDate(String ds) {
        assert StringUtils.isNotBlank(ds);
        return String.valueOf(Long.parseLong(ds) + 7);
    }

    public static String getObjectId(String ds) {
        assert StringUtils.isNotBlank(ds);
        return ds + "_" + SYN_TC_ID_SUF;
    }

    public static void main(String[] args) {
        System.out.println(getDetailName("20220920", "product"));
        System.out.println(getDetailName("20220921", "product"));
        System.out.println(verifyDate("20220920"));
        System.out.println(verifyDate("20220919"));
        System.out.println(verifyDate("2022-09-19"));
        System.out.println(verifyDate("2022-0919"));
    }
}
