package com.winhc.data.push.utils;


import com.aliyun.oss.*;
import com.aliyun.oss.internal.OSSHeaders;
import com.aliyun.oss.model.*;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author π
 * @Description:
 * @date 2022/11/14 18:02
 */

public class OssUtils {

    //安硕key
//    public static String accessKeyId = "LTAI5tDrbWcjKkzTnJXCrwkC";
//    public static String accessKeySecret = "AWDvBsQc16AYMszNVRga5ANbzuLowy";

    //内部key
    public static String accessKeyId = "LTAI6HKo33DbtiBI";
    public static String accessKeySecret = "8FmSBhHyaz4jtyJhiimK0NGF5rBPMl";


    public static String endpoint ;
    public static String bucketName = "data-exchange-as";


    static {
        if (BaseUtils.isWindows()) {
            endpoint = "oss-cn-shanghai.aliyuncs.com";
        } else {
            endpoint = "oss-cn-shanghai-internal.aliyuncs.com";
        }
    }

    public static OSS getOssClient() {
        return new OSSClientBuilder().build(endpoint, accessKeyId, accessKeySecret);
    }



    public static void uploadFile(String objectName, String filePath) {
        OSS ossClient = null;
        try {
            ossClient = getOssClient();
            // 创建PutObjectRequest对象。
            PutObjectRequest putObjectRequest = new PutObjectRequest(bucketName, objectName, new File(filePath));
            // 如果需要上传时设置存储类型和访问权限，请参考以下示例代码。
            ObjectMetadata metadata = new ObjectMetadata();
            metadata.setHeader(OSSHeaders.OSS_STORAGE_CLASS, StorageClass.Standard.toString());
            metadata.setObjectAcl(CannedAccessControlList.PublicRead);
            putObjectRequest.setMetadata(metadata);

            // 上传文件。
            ossClient.putObject(putObjectRequest);
        } catch (Exception ce) {
            System.out.println("Error Message:" + ce.getMessage());
        } finally {
            if (ossClient != null) {
                ossClient.shutdown();
            }
        }
    }

    public static List<String> listKeys(String bucket_name,String prefix) {
        OSS ossClient = getOssClient();
        // 构造ListObjectsRequest请求
        ListObjectsRequest listObjectsRequest = new ListObjectsRequest(bucket_name);
        listObjectsRequest.setMaxKeys(1000);
        //Delimiter 设置为 “/” 时，罗列该文件夹下的文件
        //listObjectsRequest.setDelimiter("/");
        //Prefix 设为某个文件夹名，罗列以此 Prefix 开头的文件
        listObjectsRequest.setPrefix(prefix);
        ObjectListing listing = ossClient.listObjects(listObjectsRequest);
        // 遍历所有Object:目录下的文件
        List<String> list_keys = listing.getObjectSummaries()
                .stream()
                .map(OSSObjectSummary::getKey)
                .filter(s -> s.endsWith(".json"))
                .collect(Collectors.toList());
        ossClient.shutdown();
        return list_keys;
    }


    public static void main(String[] args) {

        String objectName = "anshuo/tmp/20221122.zip";
        String filePath = "D:\\tmp\\data\\20221122.zip";

        //uploadFile(objectName, filePath);
        List<String> res = listKeys("data-exchange-as", "anshuo/wenshu/20240114/");
//        List<String> res1 = listKeys("data-exchange-out-tc", "data/");
//        List<String> res2 = listKeys("data-exchange-out-tc", "data/tc");
        System.out.println(res);
    }


}