package com.winhc.data.push;

import com.aliyun.odps.Odps;
import com.winhc.data.push.service.OdpsService;
import com.winhc.data.push.service.SynDataService;
import com.winhc.data.push.service.TouchService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.Arrays;
import java.util.List;

import static com.winhc.data.push.common.Constant.*;


/**
 * @author π
 * @Description:
 * @date 2022/7/21 14:19
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class TestPush {

    @Autowired
    SynDataService synDataService;

    @Autowired
    TouchService touchService;

    @Autowired
    OdpsService odpsService;


    @Test
    public void sendKafka() {
        String ds = "20220721";
        synDataService.push("", "");
    }

    @Test
    public void touchTask() {
        touchService.export2OSS("winhc_ng", "20220721");
    }

    @Test
    public void touchTask1() throws Exception {
        synDataService.sendMessage("运行中...");
    }


    @Test
    public void touchTaskTC() {
        String ds = "20231221";
        touchService.export2OSSTc("winhc_ng", ds, Arrays.asList("zxr_evaluate"));
        synDataService.saveObject(ds, TC_BUCKET_NAME, TC_OSS_PRE);
    }

    @Test
    public void touchTaskTCSum() {
        synDataService.saveObject("20231226", TC_BUCKET_NAME, TC_OSS_PRE);
        synDataService.saveObject("20231225", TC_BUCKET_NAME, TC_OSS_PRE);
        synDataService.saveObject("20231227", TC_BUCKET_NAME, TC_OSS_PRE);
    }

    @Test
    public void showTable() {

        List<String> query = odpsService.query("SHOW PARTITIONS bds_data_out_tc PARTITION (ds = '@ds') ;", "20231225");
        System.out.println(query);
    }

    @Test
    public void saveEmpty() {
        synDataService.saveEmptyObject("20240115");
    }
    @Test
    public void tt() {
        String ss = "data/tc/20231220/company_send_announcement/0a727f5343df6bc6b7861baa2998b13a.json";

        String re = ss.substring(0, ss.lastIndexOf("/"));
        String re2 = re.substring(re.lastIndexOf("/") + 1);
        System.out.println(re2);
    }

    @Test
    public void cc() {

        List<String> list_old = Arrays.asList("company",
                "company_holder",
                "company_staff",
                "private_enterprise",
                "company_liquidating_info",
                "company_change",
                "company_annual_report",
                "company_annual_report_out_investment",
                "company_annual_report_out_guarantee",
                "company_annual_report_change",
                "company_annual_report_equity_change",
                "company_annual_report_holder",
                "company_annual_report_webinfo",
                "company_annual_report_social_security",
                "company_dishonest_info",
                "company_zxr",
                "company_zxr_restrict",
                "company_zxr_final_case",
                "company_send_announcement",
                "wenshu_detail_v2",
                "company_court_open_announcement",
                "company_court_register",
                "company_court_announcement",
                "company_judicial_assistance",
                "auction_tracking",
                "zxr_evaluate_results",
                "zxr_evaluate",
                "restrictions_on_exit",
                "litigation_mediation",
                "bankruptcy_open_case",
                "bankruptcy_open_announcement",
                "bankruptcy_judgment_document",
                "company_punishment_info_creditchina",
                "company_abnormal_info",
                "company_equity_info",
                "company_mortgage_info",
                "company_mortgage_pawn",
                "company_mortgage_change",
                "company_mortgage_people",
                "company_env_punishment",
                "company_tax_contravention",
                "company_own_tax",
                "company_illegal_info",
                "company_brief_cancel_announcement",
                "company_brief_cancel_announcement_objection",
                "company_brief_cancel_announcement_result",
                "company_equity_pledge",
                "company_ipr_pledge",
                "cancellation_announcement",
                "company_bid_all",
                "company_employment",
                "company_certificate",
                "company_customs_credit",
                "company_customs_credit_administrative_penalty",
                "company_customs_credit_rating",
                "company_license_creditchina_new",
                "company_land_publicity",
                "company_land_announcement",
                "company_land_transfer",
                "company_land_mortgage",
                "company_tax",
                "company_finance",
                "company_check_info",
                "property_rights_transaction",
                "company_double_random_check_info",
                "company_double_random_check_result_info",
                "company_tm",
                "company_tm_notice",
                "company_tm_step",
                "company_tm_goods",
                "company_patent_new",
                "company_copyright_reg",
                "company_copyright_works",
                "company_icp",
                "construction_qualification",
                "construction_person",
                "construction_project",
                "company_holder_sponsor",
                "company_app_info",
                "company_bond",
                "company_public_announcement",
                "company_stock",
                "company_team_member",
                "company_tele_license",
                "company_tele_license_annual_report",
                "company_tele_license_communication_badness",
                "company_wechat",
                "company_weibo",
                "organization",
                "organization_company_relation",
                "organization_invest",
                "product",
                "product_competition");
        System.out.println("\n=======11111=======\n");
        list_old.stream().filter(s-> !tc_tns.contains(s)).forEach(System.out::println);
        System.out.println("\n=======222222=======\n");
        tc_tns.stream().filter(s-> !list_old.contains(s)).forEach(System.out::println);

    }
}
